                                 
  
                          

                                                                            
                                                                 

                                                                                    
                                       
uniform float time;
uniform vec2 resolution;

                                                                                     
                             
                                                                                                     
                                                                                                                          

                                                                                
                                                        
                                        

                                                   
uniform sampler2D texture_sampler;

                                                   
uniform sampler2D texts;


float bar = time;                                                                                                                                                              

float maxballs = 0.0;
float globalfade = 0.0;


vec3 lipo = vec3(sin(time*2.7)*3.0, 4.0+sin(time*1.7)*2.0, -1.0+sin(time*1.9)*8.0),                  
  lico = vec3(1.0, .8, .6)  * (1.0 + sin(time * .3) * 0.3) *  (1.0+fract(bar)*fract(bar*4.0));               


float sphere(vec3 p, float r)
{
  return length(p) - r;
}

                                                                                                    
vec2 matmin(vec2 mm, float d, float m)
{
  if (d < mm.x)
    return vec2(d, m);
  else
    return mm;
}

float sqr(float f) { return f*f; }

                                                                                                  
float sdtf(vec3 p, vec3 rd, float fh)
{
  float y = p.y-fh;
  float yzd = sqrt(sqr(y)+sqr(rd.z * y / rd.y)+sqr(rd.x * y / rd.y));
  return yzd * sign(y);
}

                                                                                                                                           
float df(vec3 p, vec3 rd, inout float m)
{  
  float fd = sdtf(p, rd, -2.0);                                           
  vec2 r = vec2(fd, -1.0);

  for (float i=0.0;i<7.0;i+=1.0) {
    if (i >= maxballs) break;
    r = matmin(r, sphere(p - vec3(11.0-i*4.0, 0.0 + sin(i+time), 5.0+sin(i*2.+time*2.3)*1.8), 2.0), 1.0 + i);
  }
                      
  if (m!=0.0)
    r = matmin(r, sphere(p - lipo, 1.0), 0.0);
  m = r.y;
  return r.x;
}

float shade(vec3 p)
{
  vec3 lv=normalize(lipo-p);
  float r=1.0, s=.4;
  p += lv*s;
  for (float i=0.0;i<100.0;i+=1.0) {
    float dummy=0.0, d=df(p, lv, dummy);
    r=min(r, d/s);
    p += lv*d*0.1;
    if (distance(p, lipo) < 0.1) break;
  }
  return r;
}


void main(void)
{
  vec2 uv = vec2(gl_FragCoord.xy / resolution);
  uv -= 0.5;
  uv /= vec2(resolution.y / resolution.x, 1);

if (time > 0.0) {

                                                                            
  
  globalfade = smoothstep(0.0, 1.0, bar);           

  if (bar <= 4.0) {
 maxballs = 0.0;
  } else if (bar < 8.0) {
 maxballs = 5.0;
  } else if (bar < 12.0) {
 maxballs = 2.0;
  } else if (bar < 16.0) {
 maxballs = 2.0;
  } else if (bar < 24.0) {
 maxballs = 2.0;
  } else if (bar < 29.0) {
 maxballs = 2.0;
  } else if (bar < 31.0) {
 maxballs = 2.0 - floor((bar - 30.0) * 2.0);
  } else {
 globalfade = smoothstep(32.0, 31.0, bar);
  }


                                              

  vec3 ro=vec3(sin(time*.31)*2.0, 12.0 + sin(time*.13), -15.0 + sin(time*.37)*5.0),              
    lap=vec3(0.0, 0.0, 1.0),                  
    fwv=normalize(lap-ro),                     
    upv=vec3(0.0, 1.0, 0.0),              
    rtv=cross(upv, fwv);                     
    upv=cross(fwv, rtv);                         
  mat3 rotmat=mat3(rtv, upv, fwv);                   
  vec3 sp=rotmat*vec3(uv, 1.0)+ro,                                                             
    rd=normalize(sp-ro),                      
    p=ro;                                                                                                    

  float contrib=1.0;                                                      
  vec3 l=vec3(0.0);                                                                                       

                      
  for (float i=0.0; i<100.0; i+=1.0) {
    float m=1.0,                   
      d=df(p, rd, m);                               

    if (d<0.0)                                                
      { p += d*rd; d = 0.0; }

                                                                
    if (d<0.000001) {
      float a=m;         
      vec3 e=vec3(0.001, 0.0, 0.0),             
          nv = normalize(vec3(df(p-e.xyy, rd, a), df(p-e.yxy, rd, a), df(p-e.yyx, rd, a))),                         
          lv = normalize(p-lipo),                 
          matcol = vec3(mod(m*.9, 1.0), mod(m*.7, 1.0), mod(m*.5, 1.0));                  

      if (m!=0.0) {

         l = mix(l,
            max(dot(lv, nv),0.0)*matcol*lico*shade(p),
            contrib); 

        contrib *= 0.2;
        if (contrib < 0.01) break;
        rd = reflect(rd, nv);
        p += rd * .0001;
      } else {
        l = mix(l,
            lico,
            contrib);
      }
    } else {                                          
      p += rd*d;                      
                                                                                   
                                                    
                             
    }
    
    if (length(p) > 99.0) break;                                    
  }                         


                                                                            
                                                                                                                                                 

               
  vec2 texttop = vec2(0., -.35), pt = (gl_FragCoord.xy / resolution) - texttop;
  if (pt.y > 0.)
    l = l + texture2D(texts, pt).rgb;

  gl_FragColor = vec4(l * (globalfade + (1.0-mod(bar*2.0 + 0.5, 1.0))), 1.0);

                                                                            
                                                          


} else {

                                                       
                                                     

  vec4 c = texture2D(texture_sampler, (gl_FragCoord.xy / resolution )),
       c1 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(1.0, 0.0)) / resolution) ),
       c2 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(0.0, 1.0)) / resolution) ),
       c3 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(1.0, 1.0)) / resolution) ),
       c4 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(-1.0, 1.0)) / resolution) ),
       c5 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(-1.0, 0.0)) / resolution) ),
       c6 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(-1.0, -1.0)) / resolution) ),
       c7 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(0.0, -1.0)) / resolution) ),
       c8 = texture2D(texture_sampler, ((gl_FragCoord.xy + vec2(1.0, -1.0)) / resolution) )
       ;

                      
                                                                     


                                               
    gl_FragColor = sqrt(c * 2.0 + c1 + c2 + c3 + c4 + c5 + c6 + c7 + c8) / 3.0;

}

}
