
// #include <math.h>
#include "mp3player.h"
#include "mzk.h"


void __stdcall mzk_load_from_file(TCHAR *mp3filename)
{
	OpenFromFile((mp3filename));
}

void __stdcall mzk_load_from_memory(void *mp3data, unsigned int mp3datasizebytes)
{
    OpenFromMemory((BYTE *)mp3data, mp3datasizebytes);
}

void __stdcall mzk_play(void)
{
	Play();
}

unsigned long __stdcall mzk_getposition(void)
{
	return (unsigned long)(GetPosition() * 44100);
}

unsigned long __stdcall mzk_getduration(void)
{
	return (unsigned long)(GetDuration() * 44100);
}

void __stdcall mzk_close(void)
{
	Close();
}

void __stdcall mzk_render_to_buffer(unsigned char *dstbuf, unsigned int dstbuflen_bytes)
{
    CopyFromBuffer(dstbuf, dstbuflen_bytes);
}

