; Compofiller Studio by Yzi

%define BPM 90.000000
%define SAMPLE_RATE	44100
%define MP3_MAX_LENGTH_SECONDS 236
%define MAX_SAMPLES (MP3_MAX_LENGTH_SECONDS * SAMPLE_RATE)

%define LOAD_MP3_FROM_FILE

%ifdef LOAD_MP3_FROM_FILE
music_file_name:
    db 'music.mp3', 0
%endif

%ifndef LOAD_MP3_FROM_FILE
music_data:
music_data_start:
incbin 'music.mp3'
music_data_end:
%endif

music_sample_rate:
    dd SAMPLE_RATE

music_bpm:
    dd __float32__(%[BPM])

music_length_samples:
    dd MAX_SAMPLES


section .text


%macro EXPORT_FUNC 1
    export %1
   global _%1
   _%1:
   %1:
%endmacro



EXPORT_FUNC GetMusicSampleRate
        mov eax, dword [music_sample_rate]
        ret

EXPORT_FUNC GetMusicBPM
        ; mov eax, dword [music_bpm]
        fld dword [music_bpm]
        ret

EXPORT_FUNC GetMusicLengthSamples
        mov eax, dword [music_length_samples]
        ret

%ifdef LOAD_MP3_FROM_FILE
extern _mzk_load_from_file@4
%else
extern _mzk_load_from_memory@8
%endif
extern _mzk_render_to_buffer@8
extern _GetAudioPlaybackBufferLengthBytes
extern _GetAudioPlaybackBufferPtr

EXPORT_FUNC _music_render@4
	pushad

%ifdef LOAD_MP3_FROM_FILE
	push music_file_name
	call _mzk_load_from_file@4
%else
aergaerg
	push (music_data_end-music_data_start)
	push music_data_start
	call _mzk_load_from_memory@8
%endif

	call _GetAudioPlaybackBufferLengthBytes
	push eax
	
	call _GetAudioPlaybackBufferPtr
	push eax
	
	call _mzk_render_to_buffer@8
	
	popad
	ret 4
