#ifndef _MZK_H_
#define _MZK_H_

#include <windows.h>

#define BPM (144)
//#define MZK_DURATION    600
//#define MZK_RATE        44100
//#define MZK_NUMCHANNELS 2
#define MZK_RATE        (44100)
#define MZK_DURATION    (MAX_SAMPLES)
#define MZK_NUMCHANNELS 2

//#define MZK_NUMSAMPLES  (MZK_DURATION*MZK_RATE)
//#define MZK_NUMSAMPLESC (MZK_NUMSAMPLES*MZK_NUMCHANNELS)

#define MZK_NUMSAMPLES  (MAX_SAMPLES)
#define MZK_NUMSAMPLESC (MZK_NUMSAMPLES*MZK_NUMCHANNELS)

extern "C" void __stdcall mzk_load_from_file(TCHAR  *mp3filename);
extern "C" void __stdcall mzk_load_from_memory(void *mp3data, unsigned int mp3datasizebytes);
extern "C" void __stdcall mzk_play(void);
extern "C" void __stdcall mzk_render_to_buffer(unsigned char *dstbuf, unsigned int dstbuflen_bytes);
extern "C" unsigned long __stdcall mzk_getposition(void);
extern "C" unsigned long __stdcall mzk_getduration(void);
extern "C" void __stdcall mzk_close(void);

#endif